<template>
  <div
    v-click-outside="onOutsideClick"
    class="ob-order-date-picker date-wrap"
  >
    <div
      class="order-date-picker__label"
      :class="{ 'order-date-picker__label_active': isOpen }"
      :data-qa="dataQa"
      @click="toggle"
    >
      <div class="order-date-picker__label-text">
        {{ label }}
      </div>
      <div class="order-date-picker__label-value">
        <span>
          <div
            v-if="allowTypeDate"
            class="type-input-date"
            :data-qa="dataQa"
            @click="changeTypedDate"
          >
            <ob-mask
              v-model="typedDate"
              :is-masked="true"
              mask="xx.xx.xxxx, xx:xx"
              :is-validation-mask="true"
              :data-qa="dataQa"
              @on-blur="changeTypedDate"
              @on-enter="changeTypedDate"
            />
          </div>
          <div v-if="!allowTypeDate">{{ oldDate }}</div>
        </span>
        <i class="icon calendar -cobalt" />
      </div>
    </div>
    <div
      ref="datepicker"
      class="order-date-picker"
      :class="{'order-date-picker_open': isOpen}"
    >
      <div class="type-wrap">
        <ob-radio
          v-model="type"
          label="Погрузка"
          value-input="0"
          :data-qa="dataQa"
        />
        <ob-radio
          v-model="type"
          label="Выгрузка"
          value-input="1"
          :data-qa="dataQa"
        />
      </div>
      <div class="order-date-picker__content">
        <Datepicker
          ref="date"
          v-model="selectedDate"
          date-attr="ob-order-date-picker"
          :value="value.date"
          :language="language"
          :monday-first="true"
          :disabled-dates="disabledDates"
          :calendar-button="true"
          :placeholder="placeholder"
          :format="format"
          :full-month-name="true"
          input-class="customize-input"
          calendar-button-icon="icon calendar"
          :inline="true"
          :data-qa="dataQa"
          @click.native="addAllCustoms"
          @selected="selectedHandler"
        />
        <div class="order-date-picker__input-wrap">
          <span class="date-time-title">Дата и время</span>
          <div class="order-date-picker__label">
            <div class="order-date-picker__label-text">
              {{ label }}
            </div>
            <div class="order-date-picker__label-value">
              <span>{{ newDate }}</span>
            </div>
          </div>
          <ob-select
            ref="timeSelect"
            v-model="selectedTime"
            label="Время"
            :items="timeItems"
            :data-qa="dataQa"
          />
          <span
            class="btn btn-ok"
            :data-qa="dataQa"
            @click="setValue"
          >Выбрать</span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Datepicker from 'vuejs-datepicker'
import { ru, en, zh } from 'vuejs-datepicker/dist/locale'
import ObRadio from '../obRadio/index.vue'
import ObSelect from '../obSelect/index'
import ObMask from '../obMask/component/index'
import ClickOutside from 'vue-click-outside'

const SECONDS_IN_MINUTE = 60
const MINUTES_IN_HOUR = 60
const MILLISECOND_IN_SECOND = 1000

export default {
  components: {
    Datepicker,
    ObRadio,
    ObSelect,
    ObMask
  },
  directives: {
    ClickOutside
  },
  props: {
    value: {
      type: [Object],
      default: () => {
        return {
          date: new Date(),
          type: '0'
        }
      }
    },
    format: {
      type: String,
      default: 'dd.MM.yyyy'
    },
    placeholder: {
      type: String,
      default: 'дд.мм.гггг'
    },
    label: {
      type: String,
      default: 'label'
    },
    lang: {
      type: String,
      default: 'ru'
    },
    sinceTo: {
      type: Array,
      default: () => []
    },
    blockAll: {
      type: Boolean,
      default: () => false
    },
    allowHolidays: {
      type: Boolean,
      default: () => false
    },
    allowWeekends: {
      type: Boolean,
      default: () => false
    },
    allowTypeDate: {
      type: Boolean,
      default: () => false
    },
    allowAll: {
      type: Boolean,
      default: () => false
    },
    isOrder: {
      type: Boolean,
      default: () => false
    },
    dataQa: {
      type: String
    }
  },

  data () {
    return {
      langOfCalendar: { ru, en, zh },
      arrowIcon: '',
      btnsCreated: false,
      selectedDate: '',
      typedDate: '',
      typedDateOld: '',
      type: '0',
      selectedTime: 0,
      isOpen: false
    }
  },

  computed: {
    language () {
      return this.langOfCalendar[this.lang]
    },

    timeItems () {
      let items = []

      for (let i = 0; i < 24; i++) {
        items.push({
          uuid: i * MINUTES_IN_HOUR * SECONDS_IN_MINUTE * MINUTES_IN_HOUR,
          title: i + ':00'
        })
        items.push({
          uuid: (i * MINUTES_IN_HOUR + MINUTES_IN_HOUR / 2) * SECONDS_IN_MINUTE * MILLISECOND_IN_SECOND,
          title: i + ':30'
        })
      }
      return items
    },

    oldDate () {
      let date = new Date(this.value.date)
      let d = date.getDate()
      d = d < 10 ? '0' + d : d
      let m = (date.getMonth() + 1)
      m = m < 10 ? '0' + m : m
      return d + '.' + m + '.' + date.getFullYear() + ', ' + this.getHumanTime(date)
    },
    newDate () {
      let date = new Date(this.selectedDate)
      return date.getDate() + '.' + (date.getMonth() + 1) + '.' + date.getFullYear()
    },

    disabledDates () {
      const holidaysRange = this.allowHolidays ? [] : [
        {
          from: new Date(2020, 0, 1),
          to: new Date(2020, 0, 14)
        },
        {
          from: new Date(2020, 4, 1),
          to: new Date(2020, 4, 10)
        }
      ]
      let weekendRange = this.allowWeekends ? [] : [6, 0]
      const datesRange = []
      const rangesOptions = {
        default: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowHolidays: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowWeekends: {
          days: weekendRange,
          ranges: holidaysRange,
          dates: datesRange
        },
        allowAll: {}
      }
      if (this.sinceTo) {
        this.sinceTo.forEach(it => {
          holidaysRange.push({ from: new Date(it.from), to: new Date(it.to) })
        })
      }

      if (this.blockAll) {
        holidaysRange.push({ from: new Date(), to: new Date(2050, 0, 0) })
        rangesOptions.allowAll.ranges = holidaysRange
      }

      if (this.allowWeekends && this.allowHolidays) {
        weekendRange.length = 0
      }

      return this.allowHolidays ? rangesOptions.allowHolidays : this.allowWeekends ? rangesOptions.allowWeekends : this.allowAll ? rangesOptions.allowAll : rangesOptions.default
    }
  },
  watch: {
    value (to) {
      this.selectedDate = new Date(to.date)
      this.type = to.type
      this.setTypedDate()
    }
  },
  created () {
    this.selectedDate = this.value.date
    this.type = this.value.type
    this.addAllCustoms()
    this.setTypedDate()
  },

  methods: {
    toggle () {
      this.isOpen = !this.isOpen
    },
    addAllCustoms () {
      this.blockAllFromToday()
    },
    setTypedDate () {
      let date = new Date(this.value.date)
      let d = date.getDate()
      d = d < 10 ? '0' + d : d
      let m = (date.getMonth() + 1)
      m = m < 10 ? '0' + m : m
      this.typedDate = d + '.' + m + '.' + date.getFullYear() + ', ' + this.getHumanTime(date)
      this.typedDateOld = this.typedDate
    },
    changeTypedDate (event) {
      event.stopImmediatePropagation()
      if (this.typedDate.length < this.typedDateOld.length) {
        this.typedDate += this.typedDateOld.substr(this.typedDate.length)
      }

      let d = parseInt(this.typedDate.substr(0, 2)) || 1
      let m = parseInt(this.typedDate.substr(3, 2)) || 1
      let y = parseInt(this.typedDate.substr(6, 4)) || 2019
      let h = parseInt(this.typedDate.substr(12, 2)) || 0
      let i = parseInt(this.typedDate.substr(15, 2)) || 0

      d = (d > 31) ? 31 : d
      d = d < 10 ? '0' + d : d
      m = (m > 12) ? 12 : m
      m = m < 10 ? '0' + m : m

      h = (h > 24) ? 24 : h
      h = h < 10 ? '0' + h : h
      i = (i > 59) ? 59 : i
      i = i < 10 ? '0' + i : i

      this.typedDate = d + '.' + m + '.' + y + ', ' + h + ':' + i
      this.typedDateOld = this.typedDate

      let date = new Date(m + '-' + d + '-' + y + ' ' + h + ':' + i)
      this.$emit('input', { date: date, type: this.type })
    },

    closeCalendar () {
      this.$refs.date.close()
    },

    selectedHandler ($event) {
      this.selectedDate = $event.toISOString().slice(0, 10)
      this.$refs.datepicker.dataset.value = this.selectedDate
    },

    getHumanTime (date) {
      let hours = date.getHours()
      let minutes = date.getMinutes()
      let res = (hours < 10 ? `0${hours}` : hours)
      res = res + ':' + (minutes < 10 ? `0${minutes}` : minutes)
      return res
    },

    setValue () {
      let _selectedDate = new Date(this.selectedDate)
      let date = _selectedDate.getTime() - (_selectedDate.getHours() * MINUTES_IN_HOUR * SECONDS_IN_MINUTE + _selectedDate.getMinutes() * SECONDS_IN_MINUTE) * MILLISECOND_IN_SECOND
      date += this.selectedTime
      this.$emit('input', { date: new Date(date), type: this.type })
      this.isOpen = false
    },

    setValueTyped () {
      let date = new Date(this.typedDate)
      console.log(date)
    },

    blockAllFromToday () {
      if (this.blockAll) {
        this.disabledDates.ranges.push({ from: new Date(), to: new Date(2050, 0, 0) })
      }
    },

    createElement (tagName, params, inner) {
      let el = document.createElement(tagName)
      Object.keys(params).forEach(it => {
        el[it] = params[it]
      })
      return el
    },
    onOutsideClick ($event) {
      let target = $event.target
      let popper = this.$refs.datepicker
      let dropDown = $event.target.closest('.ob-dropdown__content')
      if (target === popper || popper.contains(target) || dropDown) {
        return false
      } else {
        this.isOpen = false
      }
    }
  }
}
</script>

<style lang="scss">
//   .date-wrap {
//     /*width: 100%;*/
//     z-index: 1;
//     height: 52px;
//     position: relative;
//   }

//   .order-date-picker__label {
//     width: 200px;
//     height: 52px;
//     background: #ffffff;
//     border: 1px solid #D1D2D6;
//     box-sizing: border-box;
//     border-radius: 3px;
//     padding: 8px 12px 8px 12px;
//     cursor: pointer;

//     &_active {
//       border: 1px solid #004BC8;
//     }

//     &-text {
//       font-size: 12px;
//       line-height: 12px;
//       letter-spacing: 0.4px;
//       color: #737682;
//       white-space: nowrap;
//       text-overflow: ellipsis;
//       display: block;
//       overflow: hidden;
//     }

//     &-value {
//       display: flex;
//       justify-content: space-between;
//       margin-top: 4px;
//       font-size: 16px;
//       line-height: 20px;
//       letter-spacing: 0.2px;
//       color: #191E32;

//       & > span {
//         white-space: nowrap;
//         text-overflow: ellipsis;
//         display: block;
//         overflow: hidden;
//         height: 18px;
//       }

//       & > i {
//         font-size: 24px;
//         margin-top: -9px;
//       }
//     }
//   }

// .order-date-picker {
//   display: none;
//   background-color: #ffffff;
//   box-shadow: 0px 0px 12px -2px rgba(0, 0, 0, 0.3) !important;
//   width: 500px;
//   max-width: 500px;
//   padding: 15px;

//   &_open {
//     display: block;
//   }

//   &__content {
//     display: flex
//   }

//   .vdp-datepicker {
//     display: flex;
//     justify-content: left;

//     &__calendar {
//       width: 317px;
//       max-width: 317px;
//       min-width: 317px;
//       position: absolute;
//       top: 52px;
//       box-shadow: none !important;
//       z-index: 9999 !important;
//       border: none !important;
//       padding: 0 !important;

//       div {
//         max-width: 317px;
//       }
//       .vdp-datepicker & {
//         box-shadow: none;
//       }
//     }
//   }

//   .date-label {
//     position: absolute;
//     color: #757884;
//     top: 10px;
//     font-size: 12px;
//     left: 14px;
//     z-index: 10;
//   }

//   .day__month_btn:hover {
//     background: transparent !important;
//   }

//   .day-header {
//     margin-bottom: 10px;
//     color: #737682;
//     position: relative;
//     text-transform: uppercase;

//     &::after {
//       content: "";
//       display: block;
//       width: 105%;
//       height: 1px;
//       position: absolute;
//       top: 105%;
//       left: 0;
//       background: #D1D2D6 !important;
//     }
//   }

//   .cell:not(.month) {
//     width: 40.5px !important;
//     height: 40.5px !important;
//   }

//   .cell:hover:not(.disabled) {
//     border: 1px solid transparent !important;
//   }

//   .month {
//     margin: 5px !important;
//     width: auto !important;
//   }

//   .selected:not(.day) {
//     background: #004BC8 !important;
//     color: #ffffff;
//     border-radius: 0px !important;
//   }

//   .selected:not(.month) {
//     background: #004BC8 !important;
//     color: #ffffff;
//     border-radius: 50%;
//   }

//   .disabled {
//     background: none;
//     color: #A3A5AD !important;
//   }

//   .next, .prev {
//     background: url('../../assets/img/arrow.svg') !important;
//     background-size: 40% !important;
//     background-position: center center !important;
//     background-repeat: no-repeat !important;
//   }

//   .prev {
//     transform: rotate(180deg);
//   }

//   .next::after,
//   .prev::after {
//     content: "" !important;
//     display: none;
//   }

//   .customize-input {
//     width: 100% !important;
//     border: 1px solid #D1D2D6;
//     padding: 25px 12px 8px;
//     border-radius: 3px;
//     font-size: 16px;
//     outline: none;
//     color: #191E32 !important;
//   }

//   .vdp-datepicker div {
//     width: 100%;

//   }
//    .vdp-datepicker {
//     & div:first-child {
//       display: none;
//     }
//     &__calendar {
// 		.date-wrap_order & {
// 			& > div {
// 				width: 284px;
// 			}
// 			& > header {
// 				width: 284px;
// 			}
// 		}
//     }
//   }

//   .vdp-datepicker__calendar-button {
//     position: absolute;
//     top: 50%;
//     transform: translateY(-50%);
//     right: 10px;
//   }

//   .btn-wrap {
//     display: flex;

//     .date-wrap_order & {
//       position: absolute;
//       right: 20px;
//       bottom: 20px;
//       padding: 0;
//       width: 120px !important;
//     }
//   }
// 	.type-wrap {
// 		display: flex	;
// 		margin-bottom: 40px;
// 		margin-top: 23px;

//     & > div:first-child {
//       margin-right: 24px;
//     }
// 	}
// 	&__input-wrap {
//     position: relative;
// 		display: flex;
// 		flex-direction: column;
// 		width: 150px !important;

// 		& > * {
// 			margin-bottom: 10px;
// 		}

// 		.date-time-title {
//       margin-top: 10px;
// 			font-size: 16px;
// 			line-height: 20px;
// 			letter-spacing: 0.4px;
// 			color: #737682;
// 			margin-bottom: 20px;
// 		}

//     .order-date-picker__label {
//       width: 150px;
//     }
// 	}

//   .btn {
//     color: #004BC8;
//     padding: 10px 25px;
//     cursor: pointer;
//     display: block;
//   }

//   .btn-ok {
//     position: absolute;
//     bottom: 0;
//     right: 0;
//     width: 120px;
//     height: 40px;
//     border: 2px solid #004BC8;
//     border-radius: 25px;
//     text-align: center;
//   }
// }
//   .order-date-picker__label-value {
//     position: relative;
//     .type-input-date {
//       position: relative;
//     }
//   }
</style>
